import curses
import logging


QUIT = 1
UP = 2
DOWN = 3
LEFT = 4
RIGHT = 5
ESC = 6

DEFAULT_KEY_BINDINGS = {
    ord('q'): QUIT,
    ord('w'): UP,
    ord('s'): DOWN,
    ord('a'): LEFT,
    ord('d'): RIGHT,
    27: ESC,
    curses.KEY_UP: UP,
    curses.KEY_DOWN: DOWN,
    curses.KEY_LEFT: LEFT,
    curses.KEY_RIGHT: RIGHT,
}

class UserInput(object):
    def __init__(self, scr):
        self.screen = scr
        self.last_char = 0
        self._bindings = DEFAULT_KEY_BINDINGS

    def set_bindings(self, bindings):
        self._bindings = bindings

    def getcmd(self):
        q = self.screen.stdscr.getch()
        if q != -1:
            self.last_char = q
        if self._bindings is not None:
            return self._bindings.get(q, None)
        return q
